#accuracy_scraper.pl
#takes the accuracy out of the report files
#THIS FILE MUST BE EXECUTED INSIDE THE ALL_TESTS DIRECTORY
#usage: perl accuracy_scraper.pl

my @all_dirs;
$all_dirs[0] = "bw_images";
#$all_dirs[1] = "scene_text_2";
#$all_dirs[2] = "scene_text_3";
my @accuracy_counts;
my $file_count = 0;

foreach $dir (@all_dirs) {
    
    chdir $dir;
    
    my @all_files = glob "*";
    
    foreach $file (@all_files) {
	if ($file =~ m/IMAGE/) {
	    my $is_a_directory = 0;
	    $is_a_directory = 1 if -d $file;
	    
	    unless ($is_a_directory == 1) {
		next;
	    }

	    chdir $file;

	    open REPORT, "orig_report.txt";
	    
	    while (defined($line = <REPORT>)) {
		if ($line =~ m/\d+\%\s+Accuracy/) {
		    my @fields = split(/\s+/, $line);
		    my $percentage = $fields[1];
		    my @fields = split(/%/, $percentage);
		    my $number = $fields[0];
		    $accuracy_count[0][$file_count] = $number;
		    last;
		}
	    }
	    
	    open REPORT, "processed_report.txt";
	    
	    while (defined($line = <REPORT>)) {
		if ($line =~ m/\d+\%\s+Accuracy/) {
		    my @fields = split(/\s+/, $line);
		    my $percentage = $fields[1];
		    my @fields = split(/%/, $percentage);
		    my $number = $fields[0];
		    $accuracy_count[1][$file_count] = $number;
		    last;
		}
	    }
	    
	    open REPORT, "rotated_report.txt";
	    
	    while (defined($line = <REPORT>)) {
		if ($line =~ m/\d+\%\s+Accuracy/) {
		    my @fields = split(/\s+/, $line);
		    my $percentage = $fields[1];
		    my @fields = split(/%/, $percentage);
		    my $number = $fields[0];
		    $accuracy_count[2][$file_count] = $number;
		    last;
		}
	    }
	    
	    open REPORT, "nofuzz_report.txt";
	    
	    while (defined($line = <REPORT>)) {
		if ($line =~ m/\d+\%\s+Accuracy/) {
		    my @fields = split(/\s+/, $line);
		    my $percentage = $fields[1];
		    my @fields = split(/%/, $percentage);
		    my $number = $fields[0];
		    $accuracy_count[3][$file_count] = $number;
		    last;
		}
	    }
	    
	    chdir "..";
	    $file_count += 1;
	}
    }

    chdir "..";
}

print "Average original accuracy: " . average($accuracy_count[0]) . "\n";
print "Average processed accuracy: " . average($accuracy_count[1]) . "\n";
print "Average rotated accuracy: " . average($accuracy_count[2]) . "\n";
print "Average no-fuzz accuracy: " . average($accuracy_count[3]) . "\n";

print "Std dev original accuracy: " . standard_dev($accuracy_count[0]) . "\n";
print "Std dev processed accuracy: " . standard_dev($accuracy_count[1]) . "\n";
print "Std dev rotated accuracy: " . standard_dev($accuracy_count[2]) . "\n";
print "Std dev no-fuzz accuracy: " . standard_dev($accuracy_count[3]) . "\n";

sub average {
    my $pointer = $_[0];

    my $running_sum = 0;
    my $count = 0;
    while (defined($number = $pointer->[$count])) {
	$running_sum += $number;
	$count += 1;
    }
    return $running_sum / $count;
}

sub standard_dev {
    my $pointer = $_[0];

    my $mean1 = average($pointer);
        
    my $running_sum = 0;
    my $count = 0;
    while (defined($number = $pointer->[$count])) {
	$running_sum += ($mean1 - $number)**2;
	$count += 1;
    }
    my $mean2 = $running_sum / $count;

    return sqrt($mean2);
}
