#white_space_remover.pl
#removes lines consisting only of white space from the tesseract
#output files
#THIS FILE MUST BE EXECUTED INSIDE THE ALL_TESTS DIRECTORY
#usage: perl white_space_remover.pl

my @all_dirs;
$all_dirs[0] = "bw_images";
#$all_dirs[1] = "scene_text_2";
#$all_dirs[2] = "scene_text_3";

foreach $dir (@all_dirs) {
    
    chdir $dir;
    
    my @all_files = glob "*";
    
    foreach $file (@all_files) {
	if ($file =~ m/IMAGE/) {
	    my $is_a_file = 0;
	    $is_a_file = 1 if -d $file;
	    
	    unless ($is_a_file == 1) {
		next;
	    }
	    
	    print "$is_a_file $file\n";
	    
	    chdir $file;
	    
	    my @all_tess_texts = glob "IMAGE_*_text.txt";
	    
	    foreach $tesstext (@all_tess_texts) {
		
		open TESSOUT, "<$tesstext";
		open NEWOUT, ">new_$tesstext";
		
		my $first = 0;
		
		while (defined($line = <TESSOUT>)) {
		    
		    #if we've got spaces, make sure we're not all spaces
		    if ($line =~ /(\s*)/) {
			print "HEY $first $line\n";
			if ($1 eq $line) {
			    print "This line: $line was blank.\n";
			}
			else {
			    if ($first == 1) {
				print NEWOUT "\n";	 
			    }
			    chomp $line;
			    print NEWOUT "$line";
			}
			$first = 1;
		    }
		    
		    #if we don't got spaces, print the line
		    #(preceded by a newline if we've printed other lines)
		    else {
			if ($first == 1) {
			    print NEWOUT "\n";	 
			}
			chomp $line;
			print NEWOUT "$line";   
			$first = 1;
		    }
		}
		
		close TESSOUT;
		close NEWOUT;

		rename "new_$tesstext", "$tesstext";
		}
	    chdir "..";
	}
    }

    chdir "..";
}
